#!/usr/bin/python

# This python module will send a mail message to a zope instance that has the relevent
# addtoMailFolder client present.

# $Id: addtoMailFolder.py,v 1.9 2001/09/13 01:22:32 norton Exp $

__version__='$Revision: 1.9 $'[11:-2]  

import string
import sys
import urllib

def _make_url(host='http://localhost',path='',username=None,password=None):
        user_and_pass=''

        if username and password:
                user_and_pass="%s:%s@"%(username,password)

        return host[:7] + user_and_pass + host[7:] + path

def post_mail_message(file,host='http://localhost',path='',username=None,password=None
		      ,maillist='',search='',force='',verbose=None):

        messageText = file.read()
	
	if path is '':
		print "addtoMailFolder Error: path left unspecified"
		sys.exit(1)
		
	# get a url
	url = _make_url(host,path,username,password) + '/addtoMailFolder'
	try:
		result = urllib.urlopen(url,
					urllib.urlencode({'file':messageText
							  , 'batch':1
							  , 'maillist':maillist
							  , 'search':search
							  , 'force':force
							  })).read()
	except (IOError,EOFError),e:
		print "addtoMailFolder Error: Problem Connecting to server",e
		sys.exit(73)
                
	# if the addtoMailFolder method does not return 'OK', then 'something bad' happened.
	if string.find(result, 'OK', 0, 2) == -1:
		print "addtoMailFolder Error: %s" % result
		sys.exit(1)

	if verbose is not None:
		print "addtoMailFolder: %s" % result
		
	sys.exit(0)

if __name__ == '__main__':
	import getopt
        # This gets called by the MTA when a new message arrives.
        # The mail message file gets passed in on the stdin

	file = sys.stdin # First get a handle on the message file
	host = 'http://localhost'
        path = ''
        username = None
	password = None
        maillist = ''
	search = ''
	force = ''
	verbose = None

	opts, pargs = getopt.getopt(sys.argv[1:],
				    'h:p:U:P:l:sfv',
				    ['host=','path=','user=','pass=','mlist=',
				     'search','force','verbose'])
	for o in opts:
		if o[0] == '--host':
			host = o[1]
		elif o[0] == '--path':
			path = o[1]
		elif o[0] == '--user':
			username = o[1]
		elif o[0] == '--pass':
			password = o[1]
		elif o[0] == '--mlist':
		        maillist = o[1]
		elif o[0] == '--search':
			search = 1
		elif o[0] == '--force':
			force = 1
		elif o[0] == '--verbose':
			verbose = 1

	post_mail_message(file=file
			  , host=host,path=path
			  , username=username, password=password
			  , maillist=maillist, search=search, force=force
			  , verbose=verbose)
