## Script (Python) "addtoMailFolder"
##bind container=container
##bind context=context
##bind namespace=_
##bind script=script
##bind subpath=traverse_subpath
##parameters=file,batch=None,maillist=None,search=None,force=None
##title=Add man to Mail Folder
##
import StringIO
import rfc822
import time
import multifile
from DateTime import DateTime

if maillist == '':
  maillist = None
if force == '':
  force = None
if search == '':
  search = None

try:
  sio = StringIO.StringIO(file)  # Put it in a StringIO so we can play with it over and over
except:
  sio = file # StringIO not necessary ?
m = rfc822.Message(sio)  # Render the message through rfc822 so we can get the headers
sio.seek(0)

theMail = {}  # A New Dictionary

# Place all the email header in the headers dictionary in theMail
headers = theMail['headers'] = {}
for (name,value) in m.items():
  headers[name]=value
  
# put localpart in theMail
maillist = maillist or headers.get('envelope-to',headers.get('to',None))
if maillist is None:
  if force is None:
    raise KeyError, 'neither maillist given or envelope-to or to found in supplied mail message'
  else:
    maillist = ''
theMail['maillist'] = context.addtoMailFolder_get_local_part(maillist)

# Process mime encoded mail messages
mf = multifile.MultiFile(sio,0)
theMail['body'] = ''
theMail['attachments'] = {}
context.addtoMailFolder_unpack_part(theMail,mf,1)

# create MailMessage
# subject
theMail['subject'] = theMail['maillist']
# to
theMail['to'] = headers.get('to', None)
# title
title = headers.get('subject', None)
# sender
theMail['sender'] = headers.get('from', None)
# cc
theMail['cc'] = headers.get('cc', None)
# in_reply_to
theMail['in_reply_to'] = headers.get('in-reply-to', None)
theMail['message_id'] = headers.get('message-id', "missing_id.%s" % DateTime().timeTime())
# date
date = headers.get('date', None)
if date is not None:
  try:
    date = rfc822.parsedate(date)
  except ValueError:
    date = None
if date is not None:
  try:
    date = time.asctime(date)
  except ValueError:
    date = None
if date is not None:
  try:
    date = DateTime(date)
  except DateTime.SyntaxError:
    date = None
if date is None:
  date = DateTime()
theMail['date'] = date

# search for appropriate maillist and mail folder
mail_folders = []
if search is None:
  mail_folders.append(context)
elif theMail['maillist'] != '':
  for i in context.portal_catalog.searchResults( Type = 'MailFolder'
                                                 , Subject = theMail['maillist']
                                                 , sort_on='created'
                                                 #, sort_order='reverse'
                                                 ):
    mail_folders.append(i.getObject())
    break # only support one mail_folder at this time

# no matching mail folders found unless force
if len(mail_folders) == 0:
  if force is None and batch is None:
    url = '%s/%s' % (context.absolute_url(), context.getTypeInfo().getActionById('view', ''))
    return RESPONSE.redirect(url + '?portal_status_message=No matching mail folders found. ' )
  elif force is None and batch is not None:
    return 'NOT OK\n%s' % 'No matching mail folders found.'
  else:
    mail_folders.append(context)

# create MailMessage object
for i in mail_folders:
  if batch is None:
    return i.invokeFactory('MailMessage'
                           , id=None
                           , title=title
                           , RESPONSE=context.REQUEST.RESPONSE
                           , **theMail)
  else:
    i.invokeFactory('MailMessage'
                    , id=None
                    , title=title
                    , RESPONSE=context.REQUEST.RESPONSE
                    , **theMail)
    return 'OK\n%s' % context.REQUEST.RESPONSE
